﻿using System;
using System.Windows.Controls;

namespace SudokuMachine
{
    class BowlView
    {
        private MatrixView _matrix;
        private BowlGun _gun;

        public Decorator Chrome { get { return _matrix.Chrome; } }

        public BowlView(BarSlot countSlot, Random seed)
        {
            _matrix = new MatrixView(countSlot);
            _gun = new BowlGun(_matrix, seed);
        }

        internal void Bind(KegBank[] banks)
        {
            _matrix.Bind(banks);
        }

        internal CellView[] GetCells()
        {
            return _matrix.GetCells();
        }

        internal void Reset(int value)
        {
            _matrix.Reset(value);
        }

        internal void Bubble()
        {
            _gun.Fire();
        }
    }

    class BowlGun
    {
        private CellView[] _cells;
        private Random _random;

        public BowlGun(MatrixView matrix, Random seed)
        {
            _cells = matrix.GetCells();
            _random = new Random(seed.Next());
        }

        internal void Fire()
        {
            _cells[_random.Next(81)].Hit();
        }
    }
}